;==============   I2C==============
;  20 
Delay_5uS
		movlw 	h'80'
		movwf	Del_Counter
;		movlw 	h'03';
;		movwf	Del_Counter2
;		movlw 	h'03'
;		movwf	Del_Counter3

Del_loop
		decfsz	Del_Counter,f
		goto	Del_loop
;		decfsz	Del_Counter2,f
;		goto	Del_loop
;		decfsz	Del_Counter3,f
;		goto	Del_loop
		return		
;   


SCL_1
		bsf 	PORTA_temp,0
;		call	Out_PORTA
		movf	PORTA_temp,w
		movwf	PORTA
		return
SCL_0
		bcf 	PORTA_temp,0
;		call	Out_PORTA
		movf	PORTA_temp,w
		movwf	PORTA
		return
SDA_1
		bsf		STATUS,RP0		;   
		bsf		SDA 
		bcf		STATUS,RP0		;   
		return
SDA_0
		bsf		STATUS,RP0		;   
		bcf		SDA 
		bcf		STATUS,RP0		;   
		return

;  START 
i2c_start
		call	SCL_1			;   SCL  SDA
		call	SDA_1 
		call	Delay_5uS
		call 	SDA_0 			; SDA   SCL ( START)
		call	Delay_5uS
		call 	SCL_0 			; SCL,      
		call	Delay_5uS
		return
;  START 

;  STOP 
i2c_stop
		call	SDA_0			; SDA, ..        =1
		call	SCL_1			; SCL
		call	Delay_5uS
		call 	SDA_1			;   SCL  SDA (STOP)
		call	Delay_5uS
		return
;  STOP 

;     SCL
i2c_clk
		call	Delay_5uS
		call	SCL_1			; SCL
		call	Delay_5uS
		call	SCL_0			; SCL
		call	Delay_5uS
		return
;      SCL

;   ACK
i2c_send_ack
		call	SDA_0			; SDA
		call	i2c_clk			;   SCL
		call	SDA_1			; SDA
		call	Delay_5uS
		return
;    ACK

;   NOT_ACK
i2c_send_no_ack
		call	SDA_1			; SDA
		call	i2c_clk			;   SCL
		call	Delay_5uS
		return
;    NOT_ACK

;   ACK ( ,    )
i2c_reseive_ack
		call	SDA_1			; SDA   
		call	i2c_clk			;   SCL
		call	Delay_5uS
		return
;    ACK

;     i2c
i2c_byte_send
		movlw	b'10000000'		;   7-
		movwf	i2c_slider
Send_next_bit
		btfsc	i2c_data,7		; 7-  =1, 
		call	SDA_1			; SDA  1
		btfss	i2c_data,7		; 7-  =0,  
		call	SDA_0			; SDA  0

		call	i2c_clk			; clock   SCL

		rlf		i2c_data,f		;     1 
		bcf		STATUS,C		;    
		rrf		i2c_slider,f	;  
		btfss	STATUS,C		;      C
		goto	Send_next_bit	; 8   ,   
;		call	SDA_0
		return
;    

;   
i2c_adress_send
		movf	i2c_adress,w	;  
		movwf	i2c_data		;     
		call	i2c_byte_send	;      
		return
;   

;    
i2c_byte_reseive
		movlw	b'00000001'		;   7-
		movwf	i2c_slider
		call	SDA_1			; SDA ,    

Reseive_next_bit
		call	SCL_1			; SCL,     SDA  
								;  
		call	Delay_5uS
		btfss	SDA_In			;   0, 
		bcf 	i2c_data,0		;    
		btfsc	SDA_In			;   1, 
		bsf 	i2c_data,0		;   

		call	SCL_0
		call	Delay_5uS

		rlf		i2c_slider,f	;  
		btfsc	STATUS,C		;      C
		goto	Exit_Reseive	; 8   ,   
								;  
		bcf		STATUS,C		;    
		rlf		i2c_data,f		;     1 
		goto	Reseive_next_bit;    
Exit_Reseive
		return					;    i2c_temp

;   
